#include <assert.h>
#include <stdlib.h>
#include <string.h>

#include "Person.h"
#include "new.h"
#include "new.r"

struct Person {
	void * class;	/* must be first */
	char * name;
	int age;
	char sex;
};

void * Person_ctor (void * _self, va_list * app)
{	
    struct Person * self = _self;
	char * name = va_arg(* app, char *);

	self->name = malloc(strlen(name) + 1);
	assert(self->name);
	strcpy(self->name, name);
	int age = va_arg(* app, int);
	self->age = age;
	char sex = va_arg(* app, int);
	self->sex = sex;
	return self;
}

void * Person_dtor (void * _self)
{	
    struct Person * self = _self;

	free(self->name), self->name = 0;
	return self;
}

void * Person_clone (void * _self)
{	
    struct Person * self = _self;

	return new(Person, self->name, self->age, self->sex);
}

char * Person_toString (void * _self)
{	
    struct Person * self = _self;

    char *str = malloc(100 * sizeof(char));
    // See this SO post: https://stackoverflow.com/a/5172154/1248535
    snprintf(str, 100, "name: %s, age: %d, sex: %c", self->name, self->age, self->sex);
	return str;
}

// This creates a variable _Person of type struct Class (see new.r)
// and initializes the variable: assigns the first member of
// the struct the size of struct Person (see top of this file),
// assigns the remaining members of the struct, which are function pointers,
// the function definitions shown in this file.
// Here's a good SO post showing function points in C structs:
// https://stackoverflow.com/a/59509251/1248535
struct Class _Person = {
	sizeof(struct Person),
	Person_ctor, 
	Person_dtor,
	Person_clone, 
	Person_toString
};

// This is the "Person" variable that gets passed to new(),
// not the "Person" variable in Person.h
void * Person = & _Person;
